/**
 * @file Phase10Match.cpp
 *
 * @brief Classes to represent match (i.e. laid down) cards
 *
 * @ingroup CommonTypes
 *
 * @author Devon Johnson
 *
 */

#pragma once

// Includes
#include <Phase10/Card.h>
#include <Phase10/Deck.h>
#include <Phase10/Match.h>

namespace Phase10
{
  /////////////////////////////////////////////////////////////////////////////
  // getMode
  /////////////////////////////////////////////////////////////////////////////
  static inline DeckMode getMode(bool front)
  {
    return(front ? MODE_FIFO : MODE_LIFO);
  }

  /////////////////////////////////////////////////////////////////////////////
  // Constructor
  /////////////////////////////////////////////////////////////////////////////
  Match::Match(size_t minSize, const std::string& name) :
      mMinSize(minSize), mName(name)
  {
    mDeck = std::make_shared<Deck>();
  }

  /////////////////////////////////////////////////////////////////////////////
  // add
  /////////////////////////////////////////////////////////////////////////////
  bool Match::add(const Card& card, bool front)
  {
    bool valid = canAdd(card, front);
    if(valid)
    {
      mDeck->setMode(getMode(front));
      valid = mDeck->add(card);
    }

    return valid;
  }

  /////////////////////////////////////////////////////////////////////////////
  // isComplete
  /////////////////////////////////////////////////////////////////////////////
  bool Match::isComplete() const
  {
    return(mDeck->size() >= mMinSize);
  }

  /////////////////////////////////////////////////////////////////////////////
  // isLocked
  /////////////////////////////////////////////////////////////////////////////
  bool Match::isLocked() const
  {
    return mDeck->isLocked();
  }

  /////////////////////////////////////////////////////////////////////////////
  // passAll
  /////////////////////////////////////////////////////////////////////////////
  bool Match::passAll(Deck& deck)
  {
    return mDeck->passAll(deck);
  }

  /////////////////////////////////////////////////////////////////////////////
  // passFrom
  /////////////////////////////////////////////////////////////////////////////
  bool Match::passFrom(const Card& card, Deck& deck, bool front)
  {
    bool valid = canAdd(card, front);
    if(valid)
    {
      mDeck->setMode(getMode(front));
      valid = deck.passTo(card, *mDeck);
    }

    return valid;
  }

  /////////////////////////////////////////////////////////////////////////////
  // setLocked
  /////////////////////////////////////////////////////////////////////////////
  void Match::setLocked(bool locked)
  {
    mDeck->setLocked(locked);
  }

} // namespace Phase10